// Sample's view implementation.  Check out OnFilePrint and OnFilePrintPreview
// 
// MSW - Stingray Software - http://www.unx.com/~stingray

#include "stdafx.h"
#include "afxpriv.h"
#include "ddjppv.h"
#include "ddjsamp.h"

#include "ddjDoc.h"
#include "ddjVw.h"
#include "ddjprnt.h"

//DDJ - Stuff needed because we copied the CView::OnPrint code...
#define _AFX_NO_OLE_SUPPORT
#include "..\src\afximpl.h"
#undef _AFX_NO_OLE_SUPPORT


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


BOOL bUserAbort; //This use to live in _afxWinState, just made
//it a global be able to have the abort proc in this module.

BOOL CALLBACK _DDJAbortProc(HDC, int)
{
//	_AFX_WIN_STATE* pWinState = _afxWinState;
	MSG msg;
	while (!bUserAbort&&
		::PeekMessage(&msg, NULL, NULL, NULL, PM_NOREMOVE))
	{
		if (!AfxGetThread()->PumpMessage())
			return FALSE;   // terminate if WM_QUIT received
	}
//	return !pWinState->m_bUserAbort;
	return !bUserAbort;
}

/////////////////////////////////////////////////////////////////////////////
// CDdjsampView

IMPLEMENT_DYNCREATE(CDdjsampView, CView)

BEGIN_MESSAGE_MAP(CDdjsampView, CView)
	//{{AFX_MSG_MAP(CDdjsampView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
    
    // DDJ - IMPORTANT, be sure to remove the CView:: prefix from these or
    // DDJ - the CDdjsampView version won't be called and that's where the
    // DDJ - customizations are plugged in !
	ON_COMMAND(ID_FILE_PRINT, OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDdjsampView construction/destruction

CDdjsampView::CDdjsampView()
{
	// TODO: add construction code here

}

CDdjsampView::~CDdjsampView()
{
}

BOOL CDdjsampView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CDdjsampView drawing

void CDdjsampView::OnDraw(CDC* pDC)
{
	CDdjsampDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// DDJ - To make the progress dialog more interesting, make printing kind of
	// slow.  This makes print preview slow too, but it's just a sample.
	if (pDC->IsPrinting())
	    ::SleepEx(1000,FALSE);
	
}

void CDdjsampView::OnPrint(CDC* pDC, CPrintInfo*)
{
	ASSERT_VALID(pDC);

	// Override and set printing variables based on page number
	OnDraw(pDC);                    // Call Draw
}

//  DDJ - This is where we plug in our new printing status dialog
//  DDJ
//  DDJ

void CDdjsampView::OnFilePrint()
{
	// get default print info
	CPrintInfo printInfo;
	ASSERT(printInfo.m_pPD != NULL);    // must be set

	if (GetCurrentMessage()->wParam == ID_FILE_PRINT_DIRECT)
	{
		CCommandLineInfo* pCmdInfo = AfxGetApp()->m_pCmdInfo;

		if (pCmdInfo != NULL)
		{
			if (pCmdInfo->m_nShellCommand == CCommandLineInfo::FilePrintTo)
			{
				printInfo.m_pPD->m_pd.hDC = ::CreateDC(pCmdInfo->m_strDriverName,
					pCmdInfo->m_strPrinterName, pCmdInfo->m_strPortName, NULL);
				if (printInfo.m_pPD->m_pd.hDC == NULL)
				{
					AfxMessageBox(AFX_IDP_FAILED_TO_START_PRINT);
					return;
				}
			}
		}

		printInfo.m_bDirect = TRUE;
	}

	if (OnPreparePrinting(&printInfo))
	{
		// hDC must be set (did you remember to call DoPreparePrinting?)
		ASSERT(printInfo.m_pPD->m_pd.hDC != NULL);

		// gather file to print to if print-to-file selected
		CString strOutput;
		if (printInfo.m_pPD->m_pd.Flags & PD_PRINTTOFILE)
		{
			// construct CFileDialog for browsing
			CString strDef(MAKEINTRESOURCE(AFX_IDS_PRINTDEFAULTEXT));
			CString strPrintDef(MAKEINTRESOURCE(AFX_IDS_PRINTDEFAULT));
			CString strFilter(MAKEINTRESOURCE(AFX_IDS_PRINTFILTER));
			CString strCaption(MAKEINTRESOURCE(AFX_IDS_PRINTCAPTION));
			CFileDialog dlg(FALSE, strDef, strPrintDef,
				OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, strFilter);
			dlg.m_ofn.lpstrTitle = strCaption;

			if (dlg.DoModal() != IDOK)
				return;

			// set output device to resulting path name
			strOutput = dlg.GetPathName();
		}

		// set up document info and start the document printing process
		CString strTitle;
		CDocument* pDoc = GetDocument();
		if (pDoc != NULL)
			strTitle = pDoc->GetTitle();
		else
			GetParentFrame()->GetWindowText(strTitle);
		if (strTitle.GetLength() > 31)
			strTitle.ReleaseBuffer(31);
		DOCINFO docInfo;
		memset(&docInfo, 0, sizeof(DOCINFO));
		docInfo.cbSize = sizeof(DOCINFO);
		docInfo.lpszDocName = strTitle;
		CString strPortName;
		int nFormatID;
		if (strOutput.IsEmpty())
		{
			docInfo.lpszOutput = NULL;
			strPortName = printInfo.m_pPD->GetPortName();
			nFormatID = AFX_IDS_PRINTONPORT;
		}
		else
		{
			docInfo.lpszOutput = strOutput;
			AfxGetFileTitle(strOutput,
				strPortName.GetBuffer(_MAX_PATH), _MAX_PATH);
			nFormatID = AFX_IDS_PRINTTOFILE;
		}

		// setup the printing DC
		CDC dcPrint;
		dcPrint.Attach(printInfo.m_pPD->m_pd.hDC);  // attach printer dc
		dcPrint.m_bPrinting = TRUE;
		OnBeginPrinting(&dcPrint, &printInfo);
		dcPrint.SetAbortProc(_DDJAbortProc);

		// disable main window while printing & init printing status dialog
		AfxGetMainWnd()->EnableWindow(FALSE);
#ifdef ORIG_CODE
		CPrintingDialog dlgPrintStatus(this);
		CString strTemp;

		dlgPrintStatus.SetDlgItemText(AFX_IDC_PRINT_DOCNAME, strTitle);
#ifndef _MAC
		dlgPrintStatus.SetDlgItemText(AFX_IDC_PRINT_PRINTERNAME,
			printInfo.m_pPD->GetDeviceName());
		AfxFormatString1(strTemp, nFormatID, strPortName);
		dlgPrintStatus.SetDlgItemText(AFX_IDC_PRINT_PORTNAME, strTemp);
#endif
		
		
		dlgPrintStatus.ShowWindow(SW_SHOW);
		dlgPrintStatus.UpdateWindow();
#endif //ORIG_CODE
		
		CDDJPrintDialog ddjPrintDlg(this);
		CString strTemp;
		CProgressCtrl * pProgress =
		    (CProgressCtrl*)ddjPrintDlg.GetDlgItem(IDC_PROGRESS);
		ASSERT(pProgress != NULL);

		TRACE1("Max page is %d\n",printInfo.GetMaxPage());
		pProgress->SetPos(0);
		pProgress->SetStep(1);
		pProgress->SetRange(0,printInfo.GetMaxPage());
		
		ddjPrintDlg.SetDlgItemText(AFX_IDC_PRINT_DOCNAME,strTitle);
		ddjPrintDlg.SetDlgItemText(AFX_IDC_PRINT_PRINTERNAME,
					   printInfo.m_pPD->GetDeviceName());
		AfxFormatString1(strTemp,nFormatID,strPortName);
		ddjPrintDlg.SetDlgItemText(AFX_IDC_PRINT_PORTNAME,strTemp);
		ddjPrintDlg.ShowWindow(SW_SHOW);
		ddjPrintDlg.UpdateWindow();
		
		// start document printing process
		if (dcPrint.StartDoc(&docInfo) == SP_ERROR)
		{
			// enable main window before proceeding
			AfxGetMainWnd()->EnableWindow(TRUE);

			// cleanup and show error message
			OnEndPrinting(&dcPrint, &printInfo);
#ifdef ORIG_CODE
			dlgPrintStatus.DestroyWindow();
#endif //ORIG_CODE
			ddjPrintDlg.DestroyWindow();
			dcPrint.Detach(); 
			AfxMessageBox(AFX_IDP_FAILED_TO_START_PRINT);
			return;
		}

		// Guarantee values are in the valid range
		UINT nEndPage = printInfo.GetToPage();
		UINT nStartPage = printInfo.GetFromPage();

		if (nEndPage < printInfo.GetMinPage())
			nEndPage = printInfo.GetMinPage();
		if (nEndPage > printInfo.GetMaxPage())
			nEndPage = printInfo.GetMaxPage();

		if (nStartPage < printInfo.GetMinPage())
			nStartPage = printInfo.GetMinPage();
		if (nStartPage > printInfo.GetMaxPage())
			nStartPage = printInfo.GetMaxPage();

		int nStep = (nEndPage >= nStartPage) ? 1 : -1;
		nEndPage = (nEndPage == 0xffff) ? 0xffff : nEndPage + nStep;

#ifdef ORIG_CODE		
		VERIFY(strTemp.LoadString(AFX_IDS_PRINTPAGENUM));
#endif //ORIG_CODE
		VERIFY(strTemp.LoadString(AFX_IDS_PRINTPAGENUM));
		

		// begin page printing loop
		BOOL bError = FALSE;
		for (printInfo.m_nCurPage = nStartPage;
			printInfo.m_nCurPage != nEndPage; printInfo.m_nCurPage += nStep)
		{
			OnPrepareDC(&dcPrint, &printInfo);

			// check for end of print
			if (!printInfo.m_bContinuePrinting)
				break;

#ifdef ORIG_CODE
			// write current page
			TCHAR szBuf[80];
			wsprintf(szBuf, strTemp, printInfo.m_nCurPage);
			dlgPrintStatus.SetDlgItemText(AFX_IDC_PRINT_PAGENUM, szBuf);
#endif //ORIG_CODE
			
			TCHAR szBuf[80];
			wsprintf(szBuf, strTemp, printInfo.m_nCurPage);
			ddjPrintDlg.SetDlgItemText(AFX_IDC_PRINT_PAGENUM,
						   szBuf); 
			pProgress->StepIt();
			TRACE1("Current page is %d\n",printInfo.m_nCurPage);
			
			// set up drawing rect to entire page (in logical coordinates)
			printInfo.m_rectDraw.SetRect(0, 0,
				dcPrint.GetDeviceCaps(HORZRES),
				dcPrint.GetDeviceCaps(VERTRES));
			dcPrint.DPtoLP(&printInfo.m_rectDraw);

			// attempt to start the current page
			if (dcPrint.StartPage() < 0)
			{
				bError = TRUE;
				break;
			}

			// must call OnPrepareDC on newer versions of Windows because
			// StartPage now resets the device attributes.
			if (afxData.bMarked4)
				OnPrepareDC(&dcPrint, &printInfo);

			ASSERT(printInfo.m_bContinuePrinting);

			// page successfully started, so now render the page
			OnPrint(&dcPrint, &printInfo);
			if (dcPrint.EndPage() < 0 || !_DDJAbortProc(dcPrint.m_hDC, 0))
			{
				bError = TRUE;
				break;
			}
		}

		// cleanup document printing process
		if (!bError)
			dcPrint.EndDoc();
		else
			dcPrint.AbortDoc();

		AfxGetMainWnd()->EnableWindow();    // enable main window

		OnEndPrinting(&dcPrint, &printInfo);    // clean up after printing
#ifdef ORIG_CODE
		dlgPrintStatus.DestroyWindow();
#endif //ORIG_CODE
		ddjPrintDlg.DestroyWindow();

		dcPrint.Detach();   // will be cleaned up by CPrintInfo destructor

#ifdef _MAC
		// It's common for the user to click on the printing status dialog
		// and not have the click be registered because the abort proc
		// wasn't called often enough. For this reason we call _FlushEvents
		// after printing is done so that those events don't get sent
		// through to the document window and cause unintended changes to
		// the document.

		FlushEvents(everyEvent, 0);
#endif
	    }
}


/////////////////////////////////////////////////////////////////////////////
// CDdjsampView printing

BOOL CDdjsampView::OnPreparePrinting(CPrintInfo* pInfo)
{
    //DDJ - make the framework think we have 10 pages for cooler progress bar..
    pInfo->SetMaxPage(10);
    return DoPreparePrinting(pInfo);
}

void CDdjsampView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CDdjsampView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDdjsampView diagnostics

#ifdef _DEBUG
void CDdjsampView::AssertValid() const
{
	CView::AssertValid();
}

void CDdjsampView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDdjsampDoc* CDdjsampView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDdjsampDoc)));
	return (CDdjsampDoc*)m_pDocument;
}
#endif //_DEBUG

//  DDJ - This is how we plug in our new CPreviewView
//  DDJ - IMPORTANT!!
void CDdjsampView::OnFilePrintPreview()
{
	// In derived classes, implement special window handling here
	// Be sure to Unhook Frame Window close if hooked.

	// must not create this on the frame.  Must outlive this function
	CPrintPreviewState* pState = new CPrintPreviewState;

	// DoPrintPreview's return value does not necessarily indicate that
	// Print preview succeeded or failed, but rather what actions are necessary
	// at this point.  If DoPrintPreview returns TRUE, it means that
	// OnEndPrintPreview will be (or has already been) called and the
	// pState structure will be/has been deleted.
	// If DoPrintPreview returns FALSE, it means that OnEndPrintPreview
	// WILL NOT be called and that cleanup, including deleting pState
	// must be done here.

#ifdef ORIG_CODE //DDJ - Replace CPreviewView with your derivative.
	    if (!DoPrintPreview(AFX_IDD_PREVIEW_TOOLBAR, this,
				RUNTIME_CLASS(CPreviewView), pState))
#endif //ORIG_CODE
	    if (!DoPrintPreview(AFX_IDD_PREVIEW_TOOLBAR, this,
				RUNTIME_CLASS(CDDJPrintPreview), pState))
	{
		// In derived classes, reverse special window handling here for
		// Preview failure case

		TRACE0("Error: DoPrintPreview failed.\n");
		AfxMessageBox(AFX_IDP_COMMAND_FAILURE);
		delete pState;      // preview failed to initialize, delete State now
	}

}
