unit TestForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ThreadTest, StdCtrls;

type
  TForm3Threads = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    PaintBox3: TPaintBox;
    ButtonStart: TButton;
    ButtonStop: TButton;
    procedure FormDestroy(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
  private
    Object1: TThreadBouncingObject;
    Object2: TThreadBouncingObject;
    Object3: TThreadBouncingObject;
  public
    { Public declarations }
  end;

var
  Form3Threads: TForm3Threads;

implementation

{$R *.DFM}

procedure TForm3Threads.FormDestroy(Sender: TObject);
begin
  Object1.Terminate;
  Object1.Free;
  Object2.Terminate;
  Object2.Free;
  Object3.Terminate;
  Object3.Free;
end;

procedure TForm3Threads.ButtonStartClick(Sender: TObject);
begin
  Object1.Resume;
  Object2.Resume;
  Object3.Resume;
end;

procedure TForm3Threads.FormCreate(Sender: TObject);
begin
  Randomize;   {for the object initial positions}
  Object1 := TThreadBouncingObject.Create(PaintBox1);
  Object2 := TThreadBouncingObject.Create(PaintBox2);
  Object3 := TThreadBouncingObject.Create(PaintBox3);
end;

procedure TForm3Threads.ButtonStopClick(Sender: TObject);
begin
  Object1.Suspend;
  Object2.Suspend;
  Object3.Suspend;
end;

end.
