unit ThreadTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TThreadBouncingObject = class(TThread)
  private
    ContainmentBox: TPaintBox;
    BoundsCheckBox: TRect;
    P: TPoint;
    XIncrement, YIncrement: Integer;
    procedure UpdateScreen;
  protected
    procedure Execute; override;
  public
    constructor Create(Box: TPaintBox);
  end;

const
  WIDTH = 10;
  HEIGHT = 10;
  
implementation

{$R *.DFM}

constructor TThreadBouncingObject.Create(Box: TPaintBox);
begin
  inherited Create(True);
  ContainmentBox := Box;
  BoundsCheckBox := Rect(0, 0, Box.Width - WIDTH, Box.Height - HEIGHT);
  P.X := Random(ContainmentBox.Width - WIDTH);
  P.Y := Random(ContainmentBox.Height - HEIGHT);
  XIncrement := 1;
  YIncrement := 1;
end;

procedure TThreadBouncingObject.Execute;
begin
  repeat
    begin
      {update the X position}
      P.X := P.X + XIncrement;
      if (XIncrement > 0) and (P.X >= BoundsCheckBox.Right) or
         (XIncrement < 0) and (P.X <= BoundsCheckBox.Left) then
        XIncrement := -XIncrement;
        
      {update the Y position}
      P.Y := P.Y + YIncrement;
      if (YIncrement > 0) and (P.Y >= BoundsCheckBox.Bottom) or
         (YIncrement < 0) and (P.Y <= BoundsCheckBox.Top) then
        YIncrement := -YIncrement;
      UpdateScreen;
      Sleep(10); {pause briefly}
    end
  until Terminated;
end;

procedure TThreadBouncingObject.UpdateScreen;
begin
    ContainmentBox.Canvas.Rectangle(P.X, P.Y,
                                    P.X + WIDTH,
                                    P.Y + HEIGHT);
end;

end.